# BA CCS Track, Institut für Publizistik, JGU Mainz
# 2024-04-15

library(tidyverse)
theme_set(theme_minimal())
library(magick)
library(hfapi)
library(paws)
source("data/rekognition.R")

## Gesichtserkennung

magick::image_read("https://cdn.pixabay.com/photo/2017/06/20/22/14/man-2425121_1280.jpg")

get_faces("https://cdn.pixabay.com/photo/2017/06/20/22/14/man-2425121_1280.jpg")

## Soziodemographie von IfP-Absolvent:innen

magick::image_read("https://www.ifp.uni-mainz.de/files/2019/10/MG_4278-e1571393840928.jpg")

ifp_grad_faces <- get_faces("https://www.ifp.uni-mainz.de/files/2019/10/MG_4278-e1571393840928.jpg")
ifp_grad_faces

ifp_grad_faces |>
  add_count(gender) |>
  group_by(gender, n) |>
  summarise_at(vars(age, happy, sad, surprised), lst(mean))

### Aufgabe

## Bildbeschreibung

### Automatische Captions

magick::image_read("https://cdn.pixabay.com/photo/2020/02/29/22/41/demonstration-4891291_1280.jpg")

hfapi::image_to_text("https://cdn.pixabay.com/photo/2020/02/29/22/41/demonstration-4891291_1280.jpg")

### Generische Labels

image_classification("https://cdn.pixabay.com/photo/2020/02/29/22/41/demonstration-4891291_1280.jpg")

get_labels("https://cdn.pixabay.com/photo/2020/02/29/22/41/demonstration-4891291_1280.jpg")

get_labels("https://cdn.pixabay.com/photo/2020/02/29/22/41/demonstration-4891291_1280.jpg") |>
  pull(label)

### Aufgabe

### Spezifische Labels

magick::image_read("https://flashbak.com/wp-content/uploads/2017/04/vintage-album-cover-alcohol-24.jpg")

get_mod_content("https://flashbak.com/wp-content/uploads/2017/04/vintage-album-cover-alcohol-24.jpg")

magick::image_read("https://cdn.pixabay.com/photo/2017/03/27/13/54/bread-2178874_960_720.jpg")

hfapi::image_classification("https://cdn.pixabay.com/photo/2017/03/27/13/54/bread-2178874_960_720.jpg", url = "https://api-inference.huggingface.co/models/Kaludi/food-category-classification-v2.0")

## Was isst man auf #foodtok?

library(traktok)
options(cookiefile = "data/tt_cookie.txt")
tt_food <- traktok::tt_json("https://www.tiktok.com/tag/foodtok")$ItemModule |>
  map("video") |>
  map_chr("cover") |>
  set_names() |>
  map_df(hfapi::image_classification, url = "https://api-inference.huggingface.co/models/Kaludi/food-category-classification-v2.0", .id = "cover_url")
tt_food

tt_food |>
  count(label, sort = TRUE)

### Aufgabe

